﻿Public Class Form1

    Dim p As New Pen(Color.Black, 2)

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        For c As Integer = 0 To Me.Width Step 25
            e.Graphics.DrawLine(Pens.LightGray, c, 0, c, Me.Height)
        Next
        For r As Integer = 0 To Me.Height Step 25
            e.Graphics.DrawLine(Pens.LightGray, 0, r, Me.Width, r)
        Next
        e.Graphics.DrawEllipse(p, New Rectangle(120, 12, 100, 100))
        e.Graphics.DrawEllipse(p, New Rectangle(186, 12, 100, 100))
    End Sub

    Private Sub factorize(ByVal numbers() As Integer, ByVal listBoxes() As ListBox, ByVal outputLabels() As Label)
        If numbers.First > 9999999 OrElse numbers.Last > 9999999 Then
            MsgBox("One or both numbers too large to factorise stably", MsgBoxStyle.Information)
            Return
        End If

        For x As Integer = 0 To 1
            Dim divisors As List(Of Integer) = getDivisors(numbers(x))
            If divisors.Count <> 2 Then
                Dim levels As New List(Of Point)
                levels.Add(New Point(numbers(x), 1))
                Do
                    divisors = getDivisors(levels.Last.X)
                    If divisors.Count > 2 Then
                        levels.Add(New Point(divisors(divisors.Count - 2), divisors(1)))
                    Else
                        Exit Do
                    End If
                Loop
                Dim factors As New List(Of Integer)
                For Each p As Point In levels
                    If Not p.Y = 1 Then
                        factors.Add(p.Y)
                    End If
                Next
                factors.Add(levels.Last.X)
                factors.Sort()
                listBoxes(If(x = 0, 0, 2)).Items.Clear()
                listBoxes(If(x = 0, 0, 2)).Items.AddRange(factors.Select(Function(i) i.ToString).ToArray)
            Else
                listBoxes(0).Items.Clear()
                listBoxes(1).Items.Clear()
                listBoxes(2).Items.Clear()
                outputLabels(0).Text = "LCM ="
                outputLabels(1).Text = "HCF = "
                MsgBox(String.Format("{0} is a Prime Number", numbers(x)), MsgBoxStyle.Information)
                Return
            End If
        Next

        listBoxes(1).Items.Clear()

        For x As Integer = listBoxes(0).Items.Count - 1 To 0 Step -1
            Dim value As String = listBoxes(0).Items(x).ToString
            Dim index As Integer = listBoxes(2).FindStringExact(value)
            If index > -1 Then
                listBoxes(1).Items.Add(value)
                listBoxes(0).Items.RemoveAt(x)
                listBoxes(2).Items.RemoveAt(index)
            End If
        Next

        Dim dt As New DataTable
        Dim productString1 As String = String.Join("*", listBoxes(0).Items.Cast(Of String).ToArray)

        If listBoxes(1).Items.Count > 0 Then
            Dim productString2 As String = String.Join("*", listBoxes(1).Items.Cast(Of String).ToArray)
            productString1 &= If(listBoxes(0).Items.Count > 0, "*", "") & productString2
            outputLabels(1).Text = String.Format("HCF ({0}) = {1}", productString2, dt.Compute(productString2, Nothing))
        Else
            outputLabels(1).Text = "HCF = "
        End If

        productString1 &= If(listBoxes(2).Items.Count > 0, "*", "") & String.Join("*", listBoxes(2).Items.Cast(Of String).ToArray)
        outputLabels(0).Text = String.Format("LCM ({0}) = {1}", productString1, dt.Compute(productString1, Nothing))

    End Sub

    Private Function getDivisors(ByVal x As Integer) As List(Of Integer)
        Return New List(Of Integer)(Enumerable.Range(1, x).Where(Function(n) x Mod n = 0).ToArray)
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim n1, n2 As Integer
        If Integer.TryParse(TextBox1.Text, n1) And Integer.TryParse(TextBox2.Text, n2) Then
            factorize(New Integer() {n1, n2}, New ListBox() {ListBox1, ListBox2, ListBox3}, New Label() {Label7, Label8})
        End If
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress, TextBox2.KeyPress
        Dim tb As TextBox = DirectCast(sender, TextBox)
        e.Handled = Not Char.IsControl(e.KeyChar) AndAlso Not Char.IsDigit(e.KeyChar) OrElse (tb.Text = "" And e.KeyChar = "0"c)
    End Sub

End Class
